//AwtCopy.java

import multex.Exc;

//2000-05-23  Knabe  Umbenannt von WinCopy nach AwtCopy wg. SwingCopy
//1999-03-24  Knabe  Exc-Parameter als Object[]
//1999-03-18  Knabe  Als Demo fuer lib.Exc-Meldungsausgabe in AWT-Oberflaeche
//1999-01-15  Knabe  Als Demo fuer lib.Exc: Ausnahme mit History und Parameter
//1998-12-14  Knabe  Umbau zu binaer Kopieren
//1998-03-10  Knabe  Erstellung als Cat

/** Kopiert eine Datei, siehe Methode Copy.copy().
* Dient als Demo zur Meldung einer von unten kommenden Ausnahme in der
* AWT-Benutzeroberflche. Siehe als erstes Beispiel Copy.java.
*
* Jede in einem ActionListener der Oberflche auftretende Ausnahme wird
* mittels Aufruf von<CODE><PRE>
*    lib.Msg.report(frame, exception);
*</PRE></CODE>
* in einem PopUp-Fenster inklusive ihrer verursachenden Ausnahmen gemeldet.
* Das Meldungsfenster enthaelt einen Button "Show Stack Trace",
* der bei Bettigung den zur Programmfehlersuche interessanten
* Call-Traceback dem Meldungsfenster hinzufgt, z.B.:
*
*<code><pre>
    ----------Stack Trace follows----------
    java.io.FileNotFoundException: eingabe
            at java.io.FileInputStream.<init>(FileInputStream.java:64)
            at Copy.copy(Copy.java:62)
            at AwtCopy$1.actionPerformed(AwtCopy.java:65)
            at java.awt.Button.processActionEvent(Button.java:254)
            at java.awt.Button.processEvent(Button.java:227)
            at java.awt.Component.dispatchEventImpl(Component.java:1764)
            at java.awt.Component.dispatchEvent(Component.java:1704)
            at java.awt.EventDispatchThread.run(EventDispatchThread.java:63)
    WAS CAUSING:
    Copy$Kopierfehler: [0]=eingabe  [1]=ausgabe
            at Copy.CopyFailure(Copy.java:75)
            at AwtCopy$1.actionPerformed(AwtCopy.java:65)
            at java.awt.Button.processActionEvent(Button.java:254)
            at java.awt.Button.processEvent(Button.java:227)
            at java.awt.Component.dispatchEventImpl(Component.java:1764)
            at java.awt.Component.dispatchEvent(Component.java:1704)
            at java.awt.EventDispatchThread.run(EventDispatchThread.java:63)
</pre></code>
*/

public class AwtCopy {
  /**Effekt: Erstellt eine AWT-Oberflche zum Dateikopieren
  */
  public static void main(final String[] i_args){
    final java.util.Calendar version = java.util.Calendar.getInstance();
    version.clear();
    version.set(2000, 9,29);
    multex.Msg.report(new Copy.StartedExc("AwtCopy",version.getTime()));

    //Aufbau:

    final java.awt.Frame frame = new java.awt.Frame("AwtCopy");
    frame.setLayout(new java.awt.FlowLayout());
    frame.add(new java.awt.Label("From:"));
    final int width = 20;
    final java.awt.TextField fromTextField = new java.awt.TextField("",width);
    frame.add(fromTextField);
    frame.add(new java.awt.Label("To:"));
    final java.awt.TextField toTextField = new java.awt.TextField("",width);
    frame.add(toTextField);
    final java.awt.Button okButton = new java.awt.Button("OK");
    frame.add(okButton);
    frame.pack();

    //Verhalten:

    okButton.addActionListener( new java.awt.event.ActionListener(){
      public void actionPerformed(java.awt.event.ActionEvent i_){
        try{Copy.copy(fromTextField.getText(), toTextField.getText());}
          catch(Exception ex){multex.Msg.report(frame,ex);}
        //end try
      }
    });

    frame.addWindowListener( new java.awt.event.WindowAdapter(){
      public void windowClosing(final java.awt.event.WindowEvent i_){
        System.exit(0);
      }
    });
    frame.setVisible(true);

  }//main

/**Do not create objects of me!*/
private AwtCopy(){}

}//class AwtCopy