//SwingCopy.java
//2000-05-23  Knabe  Portierung von AWT nach Swing
//1999-03-24  Knabe  Exc-Parameter als Object[]
//1999-03-18  Knabe  Als Demo fuer multex.Exc-Meldungsausgabe in AWT-Oberflaeche
//1999-01-15  Knabe  Als Demo fuer multex.Exc: Ausnahme mit History und Parameter
//1998-12-14  Knabe  Umbau zu binaer Kopieren
//1998-03-10  Knabe  Erstellung als Cat

/** Kopiert eine Datei, siehe Methode Copy.copy().
* Dient als Demo zur Meldung einer von unten kommenden Ausnahme in der
* Swing-Benutzeroberflaeche. Siehe als erstes Beispiel Copy.java.
*
* Jede in einem ActionListener der Oberflche auftretende Ausnahme wird
* mittels Aufruf von
*    multex.Msg.report(frame, exception);
* in einem PopUp-Fenster inklusive ihrer verursachenden Ausnahmen gemeldet.
* Das Meldungsfenster enthaelt einen Button "Print Stack Trace",
* der bei Bettigung den zur Programmfehlersuche interessanten
* Call-Traceback ausgibt. Nach seiner Bettigung enthlt das Meldungsfenster
* z.B. folgende Ausgabe:
*
*<code><pre>
The file "eingabe" could not be copied to "ausgabe"
CAUSE: java.io.FileNotFoundException: eingabe (Das System kann die angegebene Datei nicht finden)

----------Stack Trace follows----------
java.io.FileNotFoundException: eingabe (Das System kann die angegebene Datei nicht finden)
  at java.io.FileInputStream.open(Native Method)
  at java.io.FileInputStream.<init>(FileInputStream.java:68)
  at Copy.copy(Copy.java:69)
WAS CAUSING:
Copy$CopyFailure: {0}=eingabe  {1}=ausgabe
  at Copy.copy(Copy.java:82)
  at SwingCopy$1.actionPerformed(SwingCopy.java:72)
  at javax.swing.AbstractButton.fireActionPerformed(AbstractButton.java:1066)
  at javax.swing.AbstractButton$ForwardActionEvents.actionPerformed(AbstractButton.java:1101)
  at javax.swing.DefaultButtonModel.fireActionPerformed(DefaultButtonModel.java:378)
  at javax.swing.DefaultButtonModel.setPressed(DefaultButtonModel.java:250)
  at javax.swing.plaf.basic.BasicButtonListener.mouseReleased(BasicButtonListener.java:204)
  at java.awt.Component.processMouseEvent(Component.java:3160)
  at java.awt.Component.processEvent(Component.java:2999)
  at java.awt.Container.processEvent(Container.java:990)
  at java.awt.Component.dispatchEventImpl(Component.java:2394)
  at java.awt.Container.dispatchEventImpl(Container.java:1035)
  at java.awt.Component.dispatchEvent(Component.java:2307)
  at java.awt.LightweightDispatcher.retargetMouseEvent(Container.java:2043)
  at java.awt.LightweightDispatcher.processMouseEvent(Container.java:1827)
  at java.awt.LightweightDispatcher.dispatchEvent(Container.java:1730)
  at java.awt.Container.dispatchEventImpl(Container.java:1022)
  at java.awt.Window.dispatchEventImpl(Window.java:749)
  at java.awt.Component.dispatchEvent(Component.java:2307)
  at java.awt.EventQueue.dispatchEvent(EventQueue.java:287)
  at java.awt.EventDispatchThread.pumpOneEvent(EventDispatchThread.java:101)
  at java.awt.EventDispatchThread.pumpEvents(EventDispatchThread.java:92)
  at java.awt.EventDispatchThread.run(EventDispatchThread.java:83)
</pre></code>
*/

public class SwingCopy {
  /**Effekt: Erstellt eine Swing-Oberflaeche zum Dateikopieren
  */
  public static void main(final String[] i_args){
    final java.util.Calendar version = java.util.Calendar.getInstance();
    version.clear();
    version.set(2000, 9,29);
    multex.Msg.report(new Copy.StartedExc("SwingCopy",version.getTime()));

    //Aufbau:

    final javax.swing.JFrame frame = new javax.swing.JFrame("SwingCopy");
    final java.awt.Container container = frame.getContentPane();
    container.setLayout(new java.awt.FlowLayout());
    container.add(new javax.swing.JLabel("From:"));
    final int width = 20;
    final javax.swing.JTextField fromTextField = new javax.swing.JTextField("",width);
    container.add(fromTextField);
    container.add(new javax.swing.JLabel("To:"));
    final javax.swing.JTextField toTextField = new javax.swing.JTextField("",width);
    container.add(toTextField);
    final javax.swing.JButton okButton = new javax.swing.JButton("OK");
    container.add(okButton);
    frame.pack();

    //Verhalten:

    okButton.addActionListener( new java.awt.event.ActionListener(){
      public void actionPerformed(java.awt.event.ActionEvent i_){
        try{Copy.copy(fromTextField.getText(), toTextField.getText());}
          catch(Exception ex){multex.Msg.report(frame,ex);}
        //end try
      }
    });

    frame.addWindowListener( new java.awt.event.WindowAdapter(){
      public void windowClosing(final java.awt.event.WindowEvent i_){
        System.exit(0);
      }
    });
    frame.setVisible(true);

  }//main

/**Do not create objects of me!*/
private SwingCopy(){}

}//class SwingCopy